<template>
  <div class="row justify-evenly">
    <q-select
      class="col-7"
      label="Serial device"
      transition-show="jump-up"
      transition-hide="jump-up"
      v-model="selectedDevice"
      :options="deviceList"
      :disable="connected"
      @popup-show="refreshList"
    />
    <q-btn
      push
      class="col-4"
      :label="connected ? 'Disconnect' : 'Connect'"
      :text-color="connected ? 'red' : 'teal'"
      @click="handleConnect"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, Ref, onMounted, computed } from 'vue';
import { Serial } from './serial';
import { useStore } from 'src/store'

export default defineComponent({
  setup() {
    const $store = useStore();
    const connected = computed(() => $store.state.status.connected);
    const selectedDevice: Ref<string> = ref('');
    const deviceList: Ref<string[]> = ref(['']);

    onMounted(() => {
      refreshList();
    });

    const refreshList = () => {
      void Serial.list().then((res) => {
        deviceList.value = res;
        selectedDevice.value = deviceList.value.length > 0 ? deviceList.value[0] : '';
      });
    };

    const handleConnect = () => {
      if (connected.value) Serial.close();
      else if (selectedDevice.value !== '') {
        Serial.open(selectedDevice.value);
      }
    };

    return {
      selectedDevice,
      refreshList,
      deviceList,
      connected,
      handleConnect,
    };
  },
});
</script>
